/*****************************************************************
 *   Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 ****************************************************************/

package org.apache.cayenne.tools;

import java.util.regex.Pattern;

import junit.framework.TestCase;

import org.apache.cayenne.map.DataMap;

public class AntDataPortDelegateTest extends TestCase {

    public void testPassedDataMapFilter() {
        AntDataPortDelegate delegate = new AntDataPortDelegate();

        // filtering should be done based on map name

        DataMap map = new DataMap();
        assertTrue(delegate.passedDataMapFilter(map));

        map.setName("A");
        assertTrue(delegate.passedDataMapFilter(map));

        delegate.mapFilters = new Pattern[] {
            Pattern.compile("B")
        };
        assertFalse(delegate.passedDataMapFilter(map));

        map.setName("BBBB");
        assertTrue(delegate.passedDataMapFilter(map));
    }
}
