/*****************************************************************
 *   Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 ****************************************************************/
package org.apache.cayenne.modeler.event;

import java.util.EventListener;


/**
 * Listener for manipulation on a callback method
 *
 * @version 1.0 Oct 25, 2007
 */
public interface CallbackMethodListener extends EventListener {

    /** Callback method changed.
     * @param e event */
    public void callbackMethodChanged(CallbackMethodEvent e);

    /** Callback method has been created/added.
     * @param e event*/
    public void callbackMethodAdded(CallbackMethodEvent e);

    /** Callback method has been removed.
     * @param e event*/
    public void callbackMethodRemoved(CallbackMethodEvent e);
}

